/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2009-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */


#ifndef headerfilecmslucoremount
#define headerfilecmslucoremount

#include <map>
#include <string>
#include <vector>



class Mount
{
public:

	struct ParamRow
	{
		typedef std::vector<std::string> ParamArg;

		bool defined;
		ParamArg arg;

		ParamRow()   { defined = false; }
		void Clear() { defined = false; arg.clear(); }
	};

	typedef std::vector<ParamRow> Param;


	long  dir_id;
	int   type;
	int   fs;
	Param param;




	Mount();
	void ClearParams();

	bool IsPar(int code);

	bool IsArg(int code, const char * arg);
	bool IsArg(int code, const std::string & arg);
	bool IsArg(int code, int arg);

	// returning the arg argument if defined (or an empty string)
	const std::string & Arg(int code, int arg) const;

	// returning the first argument (arg=0) if defined (or an empty string)
	const std::string & FirstArg(int code) const;


private:

	// for Arg() methods when the argument is not defined
	const std::string empty_str;
};



#endif

