/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_core_textstream
#define headerfile_winix_core_textstream

#include <string>



class TextStream
{
public:

	void Clear();
	const std::string & Str() const;
	const char * CStr() const;

	TextStream & operator<<(const char * str);
	TextStream & operator<<(const std::string * str);
	TextStream & operator<<(const std::string & str);

	TextStream & operator<<(char);
	TextStream & operator<<(int);
	TextStream & operator<<(long);
	TextStream & operator<<(unsigned int);
	TextStream & operator<<(unsigned long);
	TextStream & operator<<(double);
	TextStream & operator<<(const void *);// printing a pointer

protected:

	std::string buffer;

};




#endif

