/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucontenteditticket
#define headerfilecmslucontenteditticket

#include "tdb.h"
#include "ticket.h"
#include "ticketinfo.h"
#include "functions/functionbase.h"


namespace Ticket
{


class EditTicket : public FunctionBase
{
public:

	EditTicket();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	void Clear();
	bool HasAccess();
	void MakePost();
	void MakeGet();

private:

	void EditTicketCheckFirstItem();
	void EditTicketModTicket();
	void EditTicketModDir();
	void EditTicketModFirstItem();
	void PostFunEditTicketLogAndRedirect();
	bool FunCreateTicketCheckAbuse();

	TDb * tdb;
	TicketInfo * ticket_info;
};


} // namespace

#endif
